var picu = picu || {};

picu.GalleryView = Backbone.View.extend({

    tagName: 'div',
    className: 'picu-gallery',
    model: picu.appState,

    initialize: function( collection, appstate ) {
        this.appstate = appstate;
        this.collection = collection;
    },
    
    render: function() {
        this.gallery();
        return this;
    },

    gallery: function() {
        // Empty everything
        this.$el.empty();

        if ( this.collection.length > 0 ) {

            // Call statusbar function, render HTML
            var statusbar = this.statusBar();
            // Make the status bar view "global", or at least accessible in the context of this view. We need this on remove!
            this.statusBarView = statusbar;
            this.$el.append( statusbar.render().el );

            // Iterate through all images in our collection, get views back
            var galleryitems = this.collection.map( this.renderGalleryItems, this );
            // Make the galleryItems "global", or at least accessible in the context of this view. We need this on remove!
            this.galleryItems = galleryitems;

            // Iterate throught the single image views, render them and then append them to the .picu-gallery HTML element
            this.$el.append( galleryitems.map( function(num){ return num.render().el; }, this ) );
        }
        // If collection has no images (which should not be possible)
        else {
            this.$el.append( '<div class="error"><div class="error-inner">' + this.appstate.get( 'error-msg-no-imgs' ) + '</div></div>' );
        }
    },

    renderGalleryItems: function( image ) {
        var item = new picu.GalleryView.Item({model: image, appstate: this.appstate});
        var temp = item.render().el;
        return item;
    },

    statusBar: function() {
        var item = new picu.StatusBarView({model: this.appstate, collection: this.collection});
        return item;
    },

    remove: function() {
        // Remove child views
        this.statusBarView.remove();
        this.galleryItems.map( function(view){ view.remove() }, this );
    },

});