var picu = picu || {};

picu.StatusBarView = Backbone.View.extend({

    model: picu.singleImage,

    template: _.template( jQuery( "#picu-status-bar" ).html() ),

    tagName: 'header',

    className: 'picu-status-bar',

    initialize: function( options ) {
        this.collection = options.collection;
        this.appstate = options.model;

        this.update();
        this.listenTo( this.collection, 'change', function() {
            this.update();
        } );
    },

    events: {
        'click .picu-save': 'saveSelection'
    },

    update: function() {
        var all = this.collection.length;
        var selected = this.collection.where({selected: true}).length;

        var statusbar = this.template({all: all, selected: selected, poststatus: this.appstate.get( 'poststatus'), zip: this.appstate.get( 'zip' ) });
        this.$el.html( statusbar );
    },

    saveSelection: function() {

        // Hide save button, show spinner
        $( '.picu-save' ).hide();
        $( '<div class="loading">loading</div>' ).insertBefore( '.picu-save' );

        var selection = _.map( this.collection.where({selected: true}), function( s ){ return s.attributes.imageID; });

        // Send AJAX request
        $.post( this.appstate.get( 'ajaxurl' ), {

            action: 'picu_send_selection',
            security: this.appstate.get( 'nonce' ),
            postid: this.appstate.get( 'postid' ),
            selection: selection,
            intent: 'temp'

        }, function( response ) {

            // Display response as overlay
            var overlayclass = '';
            if ( response.success == true ) {
                overlayclass = ' success';
            } else {
                overlayclass = ' fail';
            }

            $( '.picu-collection' ).append('<div class="overlay'+ overlayclass +'"><div class="message"><p>' + response.data.message + '</p><p><a class="picu-button small primary js-close-message">' + response.data.button_text + '</a></p></div></div>');

            // Remove spinner, show save button
            $( '.loading' ).remove();
            $( '.picu-save' ).show();

        }).fail( function() {
            // Ajax fail
            $( '.picu-collection' ).append('<div class="overlay fail"><div class="message"><p>Error: Request failed.<br />Do you have a working internet connection?</p><p><a class="picu-button small primary js-close-message" href="#">OK</a></p></div></div>');

            // Remove spinner, show save button
            $( '.loading' ).remove();
            $( '.picu-save' ).show();
        });

    }

});